package com.danitheskunk.skunkworks.audio.nodes;

import com.danitheskunk.skunkworks.audio.AudioBuffer;
import com.danitheskunk.skunkworks.audio.AudioEngine;
import com.danitheskunk.skunkworks.audio.ISample;

public class SamplePlayer extends Node {
	private ISample sample;
	private int tick;

	public SamplePlayer(AudioEngine engine, ISample sample) {
		super(engine, 0, 1);
		this.sample = sample;
		this.tick = 0;
	}

	@Override
	public AudioBuffer getBuffer(int slot) {
		var bufsize = getEngine().getBufferSize();
		var buf = new AudioBuffer(bufsize);
		for(int i = 0; i < bufsize && tick < sample.getLength(); ++i) {
			var l = sample.getSampleLeft(tick);
			var r = sample.getSampleRight(tick);
			buf.setSample(i, l, r);
			++tick;
		}
		return buf;
	}
}
